% BVAR_IRFs 
clear all; clc; close all;
load output\imprespdrawstoreSR.mat;  
  
[ a1, a2, a3, a4 ] = size(imprespdrawstore); 
 
% shock: MP shock
shockselect = [9];

% varselect: FR DE IT SP 
varselect = [ 1 2 10 11 12; ...
              3 4 13 14 15; ...
              5 6 16 17 18; ... 
              7 8 19 20 21 ];      
 
% names of variables
varlabels = [{'RGDP'}; {'HICP'}; {'M3'}; {'LOANS'}; {'R5Y'}];
          
% reordering DE FR IT SP (benchmark first) 
vorder = [ 2; 1; 3; 4 ]; 
var_mat = varselect(vorder,:); 
         
ctnr = [ 1 1 1 2 2 3; ... 
         2 3 4 3 4 4 ]; 
ctnames = char('DE','FR','IT','ES'); 
cccn3 = '-'; 
 
aa1 = 0.25;   aa2 = 0.33; aa3 = 0.50; aa4 = 0.66;  aa5 = 0.75; 

hhz = 0 : 24; 
if max(hhz)>max(a1)
 disp('Horizon exceeds IRF length');   
end

zline = zeros(1,a1); 
 
%figure(1) 

grey1 = [0.6,0.6,0.6];
grey2 = [0.8,0.8,0.8];

nnj = size(ctnr,2);  

a10 = hhz(end)+1; 

for nnjvec = 1:size(varselect,2);

    plotind = 0;
    
    varname = char(varlabels(nnjvec));
    
    irfmedstore=NaN(hhz(end)+1,3*nnj);
    stname=cell(nnj,1);

    for jj = 1 : nnj 
        j = nnjvec; 
        % response country 1    
        cc1n = ctnr(1,jj); 
        cc1 = var_mat(cc1n,j);        
        irf1 = squeeze(imprespdrawstore(:,cc1,shockselect,:));  
        cccn1 = ctnames(cc1n,1:2);  

        % response country 2 
        cc2n = ctnr(2,jj); 
        cc2 = var_mat(cc2n,j);        
        irf2 = squeeze(imprespdrawstore(:,cc2,shockselect,:));  
        cccn2 = ctnames(cc2n,1:2); 
        ccnn12 = strcat(cccn1,cccn3,cccn2);  

        % difference 
        irf_diff = (irf1 - irf2)'; 
        irf_diff_s = sort(irf_diff); 
        irf_diff_int = [ irf_diff_s(round(aa1*a4),:); ... 
                         irf_diff_s(round(aa2*a4),:); ... 
                         irf_diff_s(round(aa3*a4),:); ...
                         irf_diff_s(round(aa4*a4),:); ...
                         irf_diff_s(round(aa5*a4),:) ]*100; 


        for kk=1:3
           irfmedstore(:,3*(jj-1)+kk)=irf_diff_int(kk,1:hhz(end)+1)';
        end

        stname(jj)={ccnn12};

        % plot 
        figure(nnjvec)
        plotind = plotind + 1; 
        subplot(3,2,plotind) 
        hb1=fill( [hhz fliplr(hhz)],  [irf_diff_int(1,1:a10) fliplr(irf_diff_int(5,1:a10))], grey2);       
        set(hb1,'EdgeColor','None');       
        hold on;
        hb2=fill( [hhz fliplr(hhz)],  [irf_diff_int(2,1:a10) fliplr(irf_diff_int(4,1:a10))], grey1);       
        set(hb2,'EdgeColor','None');               
        plot(hhz,irf_diff_int(3,1:a10),'-k',...
                 hhz,zline(1,1:a10),':k','LineWidth',2)
        xh = xlabel(ccnn12); 
        set(xh,'FontSize',12);
        axis tight;
        hd=axis;
        axis([-0.2 hd(2:4)]);
        hold off;        
        
        gettick  = get(gca,'Ytick');
    nticks = size(gettick,2);
    ticksz = gettick(2)-gettick(1);
    
    % rearrange yticks to avoid too many close entries
  
    
    if nticks>6
        
        mintick = min(gettick); maxtick = max(gettick);
        
        % add a tick if number is even
        if mod(nticks,2)==0
           
           % if maxtick is zero, add tick at bottom to keep zero
           if maxtick == 0
            
               newticks = [mintick-ticksz gettick];
               
           else
               
               newticks = [gettick maxtick+ticksz];
           
           end
            
        end
        
        % retain only every second tick
        newticks = gettick(1,1:2:nticks);
        set(gca,'Ytick',newticks);          
        
    end

    end 

    ha = axes('Position',[0 0 1 1],'Xlim',[0 1],'Ylim',[0 1], ...
            'Box','off','Visible','off','Units','normalized', 'clipping' , 'off'); 

    text(0.5, 1,varname,'HorizontalAlignment', ...
        'center','VerticalAlignment', 'top');

    druck = figure(nnjvec);
    outputdateiFigRes = strcat('output\IRFdiffs_',varname,'.eps');
    print(druck,'-depsc', outputdateiFigRes); 
    
    druck = figure(nnjvec);
    outputdateiFigRes = strcat('output\IRFdiffs_',varname,'.png');
    print(druck,'-dpng', outputdateiFigRes); 
   
   
end
