function resnew = collchains(resold)

%cchains: Collapses estimation results from multiple chains into one
%
% resraw is a structure containing 
%   
% ...
%

resnew = resold;

[k,nvars,draws,numchains]=size(resold.mcmc.beta);
fulldraws=draws*numchains;

temp = zeros(k,nvars,fulldraws);
resnew.mcmc.beta=stackmat(resold.mcmc.beta,numchains,draws,temp);

temp = zeros(nvars,nvars,fulldraws);
resnew.mcmc.sigma=stackmat(resold.mcmc.sigma,numchains,draws,temp);


if isfield(resold.mcmc,'lambda')  
   temp=zeros(fulldraws,1);
   resnew.mcmc.lambda=stackvec(resold.mcmc.lambda,numchains,draws,temp);
end

if isfield(resold.mcmc,'alpha')  
   temp=zeros(fulldraws,1);
   resnew.mcmc.alpha=stackvec(resold.mcmc.alpha,numchains,draws,temp);
end

if isfield(resold.mcmc,'theta')  
   temp=zeros(fulldraws,1);
   resnew.mcmc.theta=stackvec(resold.mcmc.theta,numchains,draws,temp);
end

if isfield(resold.mcmc,'miu')  
   temp=zeros(fulldraws,1);
   resnew.mcmc.miu=stackvec(resold.mcmc.miu,numchains,draws,temp);
end

if isfield(resold.mcmc,'PSI')  
   temp=zeros(fulldraws,nvars);
   resnew.mcmc.PSI=stackvec(resold.mcmc.PSI,numchains,draws,temp);
end

end

function newmat = stackmat(oldmat,nc,draws,tempa)

for ii=1:nc
    tempa(:,:,(ii-1)*draws+1:ii*draws)=squeeze(oldmat(:,:,:,ii));
end

newmat=tempa;

end

function newvec = stackvec(oldvec,nc,draws,tempa)

for ii=1:nc
    tempa((ii-1)*draws+1:ii*draws,:)=squeeze(oldvec(:,:,ii));
end

newvec=tempa;

end
